// 01-sampling.js

// create training dataset and validate dataset as well.
// roi: predefined area
// rnd: random generation
// pts: knowledge, reference
// ana: retrieved mapped values


var ft = {
    afaez8: '19hZjN8dbwPbDHNdLVaoGLEtmIbxAtrn4yDr9QVgt',
    afcountry: '1fGODObRcgWotUauiKV_2GlM7ZXX0sdZ5FLTJeALZ',
    afcropref: '1jlk-V9ml-5Slxt2whiefT8A9iMAyQu52_N-Cn4RM',
    afdivide7: '13VVjyzrfMQG5MswMxztEkT__2Sby-wbUbbjiBi5m',
    afgrid1d: '12RIMwSvyuOJByGe1G_ylgvagH5WzFbxHIXGqCZyB',
    afground: '1FWDClqTift4ljZdWTmo9UVg15ixCJb1EU_VFcheN',
    afgt: '1wiRq9P92gZwR8yCeWCH-X5VNOUV3EjJetQRA9sXH',
    afsimple: '1TGECZQKqqYHfRnveQLMm1c0kloc1xuILAJnOr8CK',
    afvalidset3: '1FWDClqTift4ljZdWTmo9UVg15ixCJb1EU_VFcheN',
    euro500: '1fggoQWHW3c09JEkO2290sMbvVvYSQeUO951gdLVx',
    gtrain: '1C_gFvQmd3AGtB0Q0XgnKk5ESUARSH79FB9Un8sF2',
    sacrop: '1wXVtG63mEE3obsStlLe_DsqrF3KfG-Kq7AofZUNG',
}

var debug = function(arg) { print(arg.limit(5)); } //print(arg) }
var pts = ee.FeatureCollection('ft:' + ft.afcropref) //.aside(debug)
var geom = ee.FeatureCollection('ft:' + ft.afdivide7).toList(10).get(2) //.aside(debug)

var samples = pts.map(function(f) {
    return f.set("inside", ee.Algorithms.If(f.containedIn(geom), 1, 0));
}).filter(ee.Filter.eq('inside', 1))

var crop = samples.filter(ee.Filter.eq('class', 1)).limit(100)
var nc = samples.filter(ee.Filter.eq('class', 0)).limit(100)
Map.addLayer(ee.Feature(geom))
// Map.addLayer(nc, {color:'ff0000'})
// Map.addLayer(crop, {color:'00ff00'})
// var samples = division.map(f) { return pts.map(v) {return }}

var sites = crop.merge(nc)

function cloudmask(img) {
    return img.updateMask(img.select('QA60').lt(1024)).float().multiply(1e-4)
}
var bands = ['B8', 'B4', 'B3', 'B2']
var s2 = ee.ImageCollection("COPERNICUS/S2")
var season1 = s2.filterDate('2016-3-1', '2016-5-31').map(cloudmask).select(bands).median()
var season2 = s2.filterDate('2016-9-1', '2016-11-30').map(cloudmask).select(bands).median()
var mosaic = season1.select(['B8', 'B4', 'B3', 'B2'], ['A8', 'A4', 'A3', 'A2'])
    .addBands(season2)


// var fc = ee.FeatureCollection.randomPoints(geometry2, 200)
// Map.addLayer(fc)
var ret = mosaic.reduceRegions(sites, 'mean', 20, null, null, 4).select([".*"], null, false)
Export.table.toDrive(ret, null, 'fusiontable', 'att-s2-b8-d', 'csv')

print(sites.size())